VERSION 5.00
Begin VB.Form fmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Rigol Companion"
   ClientHeight    =   6405
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   18510
   Icon            =   "fmMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   6405
   ScaleWidth      =   18510
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   6105
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "fmMain.frx":08CA
      Top             =   120
      Width           =   18255
   End
   Begin VB.CommandButton cmdRW 
      Caption         =   "Radio Wizard Data to Binary"
      Height          =   405
      Left            =   5160
      TabIndex        =   1
      Top             =   5100
      Width           =   3705
   End
   Begin VB.CommandButton cmdRWH 
      Caption         =   "Radio Wizard Data to Hex"
      Height          =   405
      Left            =   8910
      TabIndex        =   2
      Top             =   5100
      Width           =   3705
   End
End
Attribute VB_Name = "fmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MAX_LOGIC_DATA As Long = 16384 'number of data returned by rigol during "stop" state
Private Const SOA_RIGOL_HEAD As String = "SOASYSTEM RIGOL CONTROL 110"

Private Type LOGIC_DATA
    nama As String
    raw(MAX_LOGIC_DATA - 1) As Byte
    digi(MAX_LOGIC_DATA - 1) As Byte
    bin As String
    hex As String
    asc As String
    sampx As Double
    Skala As Double
    bps As Double
    bit As Long
    clock() As Byte
    drift() As Byte
End Type

Dim ifile As String
Dim dat As LOGIC_DATA

Private Sub Form_Load()
    ifile = Command()
    Text1 = ""

    'no passed command line argument
    If (Dir(ifile) = "") Or (ifile = "") Then Exit Sub

    'attempt to read passed comand line (logic data file)
    ReadLogicData ifile, dat
    DecodeBinary
    DecodeHexAscii
End Sub

'quit if "Esc" key is pressed, just a UI
Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 27 Then Unload Me
End Sub



Private Sub ReadLogicData(file As String, dat As LOGIC_DATA)
    Dim b(Len(SOA_RIGOL_HEAD) - 1) As Byte
    Dim t As String
    Dim i As Long

    'read the file
    Open file For Binary Access Read As 1
    Get #1, , b()
    Get #1, , dat
    Close 1

    'trimming comma
    For i = 1 To Len(dat.bin)
        If Mid(dat.bin, i, 1) <> "," Then
            t = t + Mid(dat.bin, i, 1)
        End If
    Next i

    dat.bin = t
End Sub

Private Sub DecodeBinary()
    Dim b As String
    Dim h As String
    Dim i As Long
    Dim j As Long

    i = getNextOne(1)
    Do Until (Len(dat.bin) - i + 1 < 3)

        'binary 1
        If Mid(dat.bin, i, 2) = "10" Then
            b = b + "1"
            i = i + 2

        'binary 0
        ElseIf Mid(dat.bin, i, 3) = "110" Then
            b = b + "0"
            i = i + 3

        'invalid data
        Else
            b = b + "-"
            i = i + 1
        End If
        
        j = getNextOne(i)
        If j > i Then b = b + ","
        i = j
    Loop

    Text1 = b
End Sub

Private Sub DecodeHexAscii()
    Dim b As String
    Dim c As String
    Dim h As String
    Dim a As String

    Dim r As String
    Dim i As Long
    Dim j As Long
    Dim cnt As Long

    b = Text1
    i = 1
    j = 1

    'how to translate the binary is up to you.
    Do Until j = 0
        j = InStr(i, b, ",", vbBinaryCompare)
        If j <> 0 Then c = Mid(b, i, j - i + 1)
        If j = 0 Then c = Mid(b, i, Len(b) - i + 1)
        
        cnt = 0
        Do Until Len(c) < 8
            cnt = cnt + 1
            r = BinToHex(Left(c, 8))
            If Len(r) < 2 Then r = String(2 - Len(r), "0") + r
            h = h + r + " "
            a = a + BinToChar(Left(c, 8))
            c = Right(c, Len(c) - 8)
        Loop
        If cnt Then
            h = h + "," + vbCrLf
            a = a + "," + vbCrLf
        End If
        
        i = j + 1
    Loop

    'show the decoded info on the textbox
    Text1 = Text1 + vbCrLf + h + vbCrLf + a
End Sub

Private Function getNextOne(sta As Long) As Long
    Dim i As Long

    'find starting point
    For i = sta To Len(dat.bin)
        If Mid(dat.bin, i, 1) = "1" Then Exit For
    Next i

    getNextOne = i
End Function
